<?php /*	
	Plugin Name: Simple Fixed Notice	
	Description: A simple fixed banner that shows a notice on the use of cookies and allows you to insert the link to the cookie policy and privacy policy.
	Version: 1.6
	Author: Digireturn	
	Author URI: https://digireturn.it/	
	License: GPLv2 or later	License 
	URI: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html	
	Text Domain: dn_cookie_notice	
	Domain Path: /languages 
*/
if(!defined('ABSPATH'))die('Invalid request.');
if(!headers_sent()&&session_id()==''){session_start();}
define('DN_COOKIE_NOTICE_PATH',dirname(__file__).'/');
define('DN_COOKIE_NOTICE_NAME','Simple Cookie Notice');
define('DN_COOKIE_NOTICE_VERSION','1.5.2');
define('DN_COOKIE_NOTICE_HOME','options-general.php?page=dn_cookie_notice_manage');
define('DN_COOKIE_NOTICE_REPOSITARY','https://wordpress.org/plugins/dn-cookie-notice/');
define('DN_COOKIE_NOTICE_SUPPORT','https://wordpress.org/support/plugin/dn-cookie-notice/');
$__dn_cookie_notice=array('settings'=>false,'logs'=>array());
add_action('admin_menu', 'dn_cookie_notice_admin_menu');
function dn_cookie_notice_admin_menu(){
	add_options_page(DN_COOKIE_NOTICE_NAME,DN_COOKIE_NOTICE_NAME,'manage_options','dn_cookie_notice_manage','dn_cookie_notice_manage');
}
function dn_cookie_notice_add_log($s=''){
	if(empty($s))return;
	global $__dn_cookie_notice;
	$__dn_cookie_notice['logs'][].=date('Y-m-d H:i:s').' '.$s;
}
function dn_cookie_notice_get_logs(){
	global $__dn_cookie_notice;	
	return implode('<br />',is_array($__dn_cookie_notice['logs'])?$__dn_cookie_notice['logs']:array());	
}
function dn_cookie_notice_update_options($options=array()){
	global $__dn_cookie_notice;
	$__dn_cookie_notice['settings']=$options;
	update_option('dn_cookie_notice_settings',$options);
}
function dn_cookie_notice_get_options(){
	global $__dn_cookie_notice;
	if(!$__dn_cookie_notice['settings']){	
		$a=get_option('dn_cookie_notice_settings');
		if(!is_array($a))$a=array();

		$__dn_cookie_notice['settings']=array(
			'version'=>isset($a['version'])?intval($a['version']):0,
			'subversion'=>isset($a['subversion'])?intval($a['subversion']):0,
			'status'=>isset($a['status'])?intval($a['status']):0,
			'time'=>isset($a['time'])?intval($a['time']):180,
			'page_id'=>isset($a['page_id'])?intval($a['page_id']):0,
			'position'=>isset($a['position'])?($a['position']):'top',
		);
		if(isset($a['policy'])||isset($a['notice'])>0){
			$__dn_cookie_notice['settings']['page_id']=dn_cookie_notice_upgrade_to_single_page(array_merge(
				$__dn_cookie_notice['settings'],array(
					'policy'=>isset($a['policy'])?intval($a['policy']):0,
					'notice'=>isset($a['notice'])?intval($a['notice']):0,
				)));
			dn_cookie_notice_update_options($__dn_cookie_notice['settings']);
			dn_cookie_notice_add_log('Nuova pagina associata #'.$__dn_cookie_notice['settings']['page_id']);
			dn_cookie_notice_session_add_notify('success',esc_html(__('DN Cookie Notice has generated a special page where you can insert the banner message and the cookie information','dn_cookie_notice')));
		}
	}
	return $__dn_cookie_notice['settings'];
}
function dn_cookie_notice_upgrade_to_single_page($options=array()){
	$page=array(
		'post_status'=>'publish',
		'post_type'=>'page',
		'post_title'=>esc_html(__('Cookie policy','dn_cookie_notice')),
		'post_name'=>sanitize_title(__('Cookie policy','dn_cookie_notice')),
		'post_content'=>''
	);
	$meta=array();
	if(isset($options['policy'])&&($p=get_page($options['policy']))){
		$page['post_title']=$p->post_title;
		$page['post_content']=$p->post_content;
	}
	if(isset($options['notice'])&&($p=get_page($options['notice']))){
		$meta['button']=$p->post_title;
		$meta['notice']=$p->post_content;
	} 
	$page_id=wp_insert_post($page);
	foreach($meta as $key=>$value)update_post_meta($page_id,$key,$value);
	return $page_id;
}
function dn_cookie_notice_manage(){
	$options=dn_cookie_notice_get_options(); 
	$page_id=intval($options['page_id']);
	$page=get_page($page_id);
	if(!$page){
		$options['page_id']=wp_insert_post(array(
			'post_title'=>esc_html(__('Cookie policy','dn_cookie_notice')),
			'post_type'=>'page',
			'post_status'=>'draft',
		));
		dn_cookie_notice_update_options($options);
		$page_id=intval($options['page_id']);
	}
	echo '<div class="wrap">'
		.sprintf('<h1><img src="%s" class="dn_cookie_notice_class_logo" />%s</h1>'
			,esc_url(plugins_url('images/logo.png',__FILE__))
			,esc_html(DN_COOKIE_NOTICE_NAME)
		)
		.'<p>'.esc_html(__('The options for cookies are available below','dn_cookie_notice')).'.&nbsp;'
		.esc_html(__('This plugin use a tecnical cookie for reminder user choose','dn_cookie_notice')).': "dn_cookie_notice_agreed".&nbsp;'
		.esc_html(__('This plugin is compatible with WPML','dn_cookie_notice')).'.</p>' 
		.'<form action="" method="post"><table class="wp-list-table widefat fixed striped dn_cookie_notice_class_table">'
		.'<tr><th>'.esc_html(__('Status','dn_cookie_notice')).'</th><td><select name="dn_cookie_notice_save[status]">'
				.'<option value="0">'.esc_html(__('Disactive','dn_cookie_notice')).'</option>'
				.'<option value="1" '.($options['status']==1?'selected':'').'>'.esc_html(__('Active','dn_cookie_notice')).'</option></select>'
		.'</td></tr>'
		.'<tr><th>'.esc_html(__('Time cookie expires','dn_cookie_notice')).'</th><td>'
			.$options['time'].' '.esc_html($options['time']==1?__('day','dn_cookie_notice'):__('days','dn_cookie_notice'))
		.'</td></tr>'
		.'<tr><th>'.esc_html(__('Cookies policy page','dn_cookie_notice')).'</th><td>'
			.'<a href="post.php?post='.esc_attr($page_id).'&action=edit" class="button" target="_blank">'
				.esc_html(__('Edit page','dn_cookie_notice'))
				.'&nbsp;#'.$page_id
			.'</a>'
		.'</td></tr>'
		.'<tr><th>'.esc_html(__('Popup position','dn_cookie_notice')).'</th><td>'
			.'<select name="dn_cookie_notice_save[position]">'
				.'<option value="top">'.esc_html(__('Top','dn_cookie_notice')).'</option>'
				.'<option value="bottom" '.($options['position']=='bottom'?'selected':'').'>'.esc_html(__('Bottom','dn_cookie_notice')).'</option>'
			.'</select>'
		.'</td></tr>'
		.'<tr><td colspan="2">'
		.'<div class="-notice notice-success"><p>'
		.sprintf(
			__('If you enjoy using %s, please take a moment to rate it on %s. Thanks for your support!','dn_cookie_notice')
			,esc_html(DN_COOKIE_NOTICE_NAME)
			,'<a href="'.esc_url(DN_COOKIE_NOTICE_REPOSITARY).'/#reviews" target="_blank">WordPress Plugin Directory</a>'
		)
		.'</p></div>'
		.'</td>
		</tr>
	</table><p><input type="submit" value="'.esc_attr(__('Update','dn_cookie_notice')).'" class="button-primary" /></p></form>'
	.'</div>'; 
	echo dn_cookie_notice_get_logs();
}
add_action('add_meta_boxes','dn_cookie_notice_add_meta_boxes');
function dn_cookie_notice_add_meta_boxes(){ 
	$options=dn_cookie_notice_get_options();
	if(!isset($_GET['post']))return;
	$post_id=intval(sanitize_text_field($_GET['post']));
	$check=array(
		$post_id,
		intval(get_post_meta($post_id,'_dn_lang_parent',true)),
	);
	if(in_array($options['page_id'],$check))
		add_meta_box('dn_cookie_notice-metabox'
			,sprintf(__('%s options page','dn_cookie_notice'),esc_html(DN_COOKIE_NOTICE_NAME))
			,'dn_cookie_notice_html_post_metabox'
			,'page'
			,'normal'
			,'high'
		);
}
function dn_cookie_notice_html_post_metabox($p){
	echo '<div class="">'
		.sprintf('<label>%s</label>',esc_html(__('Message visible on fixed banner.','dn_cookie_notice')))
		.sprintf('<br /><textarea name="dn_cookie_notice_post[notice]" class="dn_cookie_notice_class_textarea">%s</textarea>',get_post_meta($p->ID,'notice',true))
		.'<br />'.esc_html(__('Use shortcode below for get special link','dn_cookie_notice')).':&nbsp;'
		.'<br />-&nbsp;&nbsp;&nbsp;<code>[privacypagelink]</code>&nbsp;'.esc_html(__('for link at privacy policy','dn_cookie_notice'))
		.'<br />-&nbsp;&nbsp;&nbsp;<code>[cookiespagelink]</code>&nbsp;'.esc_html(__('for link at cookie policy','dn_cookie_notice'))
		.'<br />'.esc_html(__('Example (in html edit mode)','dn_cookie_notice')).':&nbsp;&lt;a href="[cookiespagelink]"&gt;'.esc_html(__('click here','dn_cookie_notice')).'&lt;/a&gt;'
		.'<br /><label for="dn_cookie_notice-button">'.esc_html(__('Insert cookie button notice label','dn_cookie_notice')).':&nbsp;&nbsp;</label>'
		.sprintf('<br /><input name="dn_cookie_notice_post[button]" value="%s" id="dn_cookie_notice-button" type="text" class="dn_cookie_notice_class_text" />'
			,esc_attr(get_post_meta($p->ID,'button',true))
		)
	.'</div>';
}
add_action('save_post','dn_cookie_notice_save_post');
function dn_cookie_notice_save_post($post_id){
	if(wp_is_post_revision($post_id)||!isset($_POST['dn_cookie_notice_post']))return;
	foreach($_POST['dn_cookie_notice_post'] as $key=>$value)
		update_post_meta($post_id
			,$key
			,sanitize_textarea_field(htmlentities(strip_tags($value,'<br><p><span><a><img><i><u><b><strong><strike><font><h1><h2><h3><h4><h5><h6>')))
		);
}
add_action('admin_init','dn_cookie_notice_save',200);
function dn_cookie_notice_save(){
	if(isset($_POST['dn_cookie_notice_save'])){
		$update=false;
		$options=dn_cookie_notice_get_options();
		if(isset($_POST['dn_cookie_notice_save']['status'])&&$_POST['dn_cookie_notice_save']['status']!=$options['status']){
			$update=true;
			$options['status']=sanitize_text_field($_POST['dn_cookie_notice_save']['status']);
		}
		if(isset($_POST['dn_cookie_notice_save']['position'])&&$_POST['dn_cookie_notice_save']['position']!=$options['position']){
			$update=true;
			$options['position']=sanitize_text_field($_POST['dn_cookie_notice_save']['position']);
		}
		if($update){
			$options['subversion']=isset($options['subversion'])?intval($options['subversion'])+1:1;
			dn_cookie_notice_update_options($options);
		}
		dn_cookie_notice_session_add_notify('success',esc_html(__('Updated settings','dn_cookie_notice')));
	}
}
add_action('init','dn_cookie_notice_init',200);
function dn_cookie_notice_init(){
	$options=dn_cookie_notice_get_options();
	if(isset($_POST['dn_cookie_notice_agreed'])||isset($_GET['dn_cookie_notice_agreed'])){
		setcookie("dn_cookie_notice_agreed",'1',(time()+(60*60*24*$options['time'])));
		$_COOKIE['dn_cookie_notice_agreed']=1;
		exit;
	}
	if(is_file(dirname(__FILE__).'/languages/dn-cookie-notice-'.get_locale().'.mo'))
		load_textdomain('dn_cookie_notice',dirname(__FILE__).'/languages/dn-cookie-notice-'.get_locale().'.mo');
	if(is_dir(dirname(__FILE__).'/languages'))
		load_plugin_textdomain('dn_cookie_notice',false,dirname(__FILE__).'/languages');
}
function dn_cookie_notice_session_add_notify($k,$v=''){
	if(strlen($v)>0&&strlen($k)>0){
		if(!isset($_SESSION['dn_cookie_notice_'.$k]))$_SESSION['dn_cookie_notice_'.$k]='';
		$_SESSION['dn_cookie_notice_'.$k].=(strlen($_SESSION['dn_cookie_notice_'.$k])>0?'<br>':'').trim(strip_tags($v,'<br>'));
	}
}
function dn_cookie_notice_session_has_notify($k){
	return (isset($_SESSION['dn_cookie_notice_'.$k])&&strlen($_SESSION['dn_cookie_notice_'.$k])>0)?true:false;
}
function dn_cookie_notice_session_read_notify($k){
	if(!dn_cookie_notice_session_has_notify($k))return;
	$s=$_SESSION['dn_cookie_notice_'.$k];
	unset($_SESSION['dn_cookie_notice_'.$k]);
	return $s;
}
add_action('admin_notices','dn_cookie_notice_session_admin_notice');
function dn_cookie_notice_session_admin_notice(){
	if(dn_cookie_notice_session_has_notify('success'))
		echo '<div class="notice notice-success is-dismissible"><p>'.dn_cookie_notice_session_read_notify('success').'</p></div>';
	if(dn_cookie_notice_session_has_notify('error'))
		echo '<div class="notice notice-error"><p>'.dn_cookie_notice_session_read_notify('error').'</p></div>';	
}

add_action('dn_cookie_notice','dn_cookie_notice_banner',200);
add_action('dn_footer','dn_cookie_notice_banner',200);
add_action('wp_footer','dn_cookie_notice_banner',200);
	function dn_cookie_notice_banner(){	if(defined('DN_COOKIE_NOTICE_BANNER_EXECUTE'))return;	define('DN_COOKIE_NOTICE_BANNER_EXECUTE',1);
	$options=dn_cookie_notice_get_options();
	$dn_cookie_notice_agreed=(isset($_COOKIE['dn_cookie_notice_agreed'])&&$_COOKIE['dn_cookie_notice_agreed']=='1')?1:0; 
	if($options['status']!=1||$dn_cookie_notice_agreed)return;
	
	$cookie_page_id=apply_filters('dn_languages_post_id',$options['page_id']);
	$privacy_page_id=apply_filters('dn_languages_post_id',get_option('wp_page_for_privacy_policy'));
	if(function_exists('icl_object_id')){
		$cookie_page_id=icl_object_id($cookie_page_id,'page',false); 
		$privacy_page_id=icl_object_id($privacy_page_id,'page',false);
	}
	$cookie_page=get_post($cookie_page_id);
	if(!$cookie_page)return;
	$button=get_post_meta($cookie_page_id,'button',true);
	if(empty($button))$button=esc_html(__('I agree','dn_cookie_notice'));
	
	$notice=html_entity_decode(get_post_meta($cookie_page_id,'notice',true)); 
	$content=str_replace(
		array('[privacypagelink]','[cookiespagelink]'),
		array(get_permalink($privacy_page_id),get_permalink($cookie_page_id)),
		$notice);
		$content=nl2br($content); 
	if(strlen($content)<10)return;
	
	switch($options['position']){
		case 'bottom':$stylePosition='bottom:0';break;
		case 'top':default:$stylePosition='top:0';
	}
	echo '<style>
			#dn_cookie_notice_banner{width:100%;background:rgba(0,0,0,0.85);position:fixed;margin-left:0;margin-right:0;z-index:999;padding-bottom: 15px;'.$stylePosition.'}
			#dn_cookie_notice_banner *{font-family:Arial, "sans serif";font-size:10pt;color:white;line-height: 12pt;}
			#dn_cookie_notice_banner a,
			#dn_cookie_notice_banner p a{text-decoration:underline;cursor:pointer}
			#dn_cookie_notice_banner a:hover,
			#dn_cookie_notice_banner p a:hover{color:red;}
			#dn_cookie_notice_banner .dn_cookie_notice_banner_class_content{width:85%;max-width:1170px;margin:0 auto;padding:10px}
			#dn_cookie_notice_banner .dn_cookie_notice_banner_class_button > a{display: inline-block;margin-top: 15px;padding: 5px 20px;color: #fff;background: transparent;border: 1px solid white;border-radius: 5px;text-transform: uppercase}
			#dn_cookie_notice_banner .dn_cookie_notice_banner_class_button > a{text-decoration:none !important;}
			#dn_cookie_notice_banner .dn_cookie_notice_banner_class_button > a:hover{background:rgba(250,250,250,0.5);color:#fff}
			#dn_cookie_notice_banner .dn_cookie_notice_banner_class_button{margin-top: 8px;}
			#dn_cookie_notice_banner .dn_cookie_notice_banner_class_notice{font-size:bold;color:#fff;float:left}
			#dn_cookie_notice_banner .dn_cookie_notice_banner_class_close{color: #ccc;font-size: 20pt;float: right;margin-bottom: 4px;cursor:pointer}
			#dn_cookie_notice_banner .dn_cookie_notice_banner_class_close:hover{color: #fff}
	</style>';
	echo '<div id="dn_cookie_notice_banner">'
			.'<div class="dn_cookie_notice_banner_class_content">'
				.'<span class="dn_cookie_notice_banner_class_close" onclick="dn_cookie_notice_js()">&times;</span>'
				.'<div class="dn_cookie_notice_banner_class_notice">'
				.$content
				.'<div class="dn_cookie_notice_banner_class_button"><a class="ok" href="javascript:void(0)" onclick="dn_cookie_notice_js()">'.$button.'</a></div>'
				.'</div>'
			.'</div>'
		.'</div>';
	echo'<script type="text/javascript">'
		.'function dn_cookie_notice_js(){
			var xhttp = new XMLHttpRequest();
			xhttp.onreadystatechange = function() {
				if (this.readyState == 4 && this.status == 200){
					if (typeof jQuery == "undefined") {
						var dn_cookie_notice_banner = document.getElementById("dn_cookie_notice_banner");
						dn_cookie_notice_banner.remove();
					}else jQuery("#dn_cookie_notice_banner").fadeOut();
				}
			};
			xhttp.open("POST","'.esc_url(get_option('siteurl')).'?dn_cookie_notice_agreed=1",true);
			xhttp.setRequestHeader("Content-type","application/x-www-form-urlencoded");
			xhttp.send("dn_cookie_notice_agreed=1");
		}
		</script>';
}
add_filter('plugin_action_links_'.plugin_basename(__FILE__),'dn_cookie_notice_filter_plugin_action_links');
function dn_cookie_notice_filter_plugin_action_links($links=array()) { 
	$links=array_merge($links,array(
		'<a href="' . admin_url(DN_COOKIE_NOTICE_HOME) . '">'.esc_html(__('Settings','dn_cookie_notice')).'</a>'
	));
	return $links;
}
add_action('admin_enqueue_scripts','dn_cookie_notice_admin_enqueue_scripts');
function dn_cookie_notice_admin_enqueue_scripts(){
    wp_enqueue_style('dn-cookie-notice-admin',esc_url(plugins_url('css/dn-cookie-notice-admin.css', DN_COOKIE_NOTICE_PATH.'/.' )),array(),DN_COOKIE_NOTICE_VERSION,false);
	//wp_enqueue_script('dn-cookie-notice-admin',esc_url(plugins_url('js/dn-cookie-notice-admin.js', DN_COOKIE_NOTICE_PATH.'/.' )),array(),DN_COOKIE_NOTICE_VERSION,true);
	//wp_localize_script('dn-cookie-notice-admin','dn_cookie_notice_admin',array('ajax_url'=>admin_url('admin-ajax.php')));
}
?>